%define prerel %nil
%def_with ffmpeg
%def_with gpl
%def_with faac
%def_without x264
%def_disable static
%define _unpackaged_files_terminate_build 1

%define _pkgdocdir %_docdir/%{name}-%{version}

Name: libquicktime
Version: 1.0.2
Release: alt4%prerel

Summary: A library for manipulating QuickTime files
%if_with gpl
License: GPL
%else
License: LGPL
%endif
Group: Video
Url: http://libquicktime.sourceforge.net
Packager: Igor Vlasenko <viy@altlinux.ru>

Source: http://dl.sf.net/%name/%name-%version%prerel.tar.gz
Patch: %{name}-1.0.2-opendivx-alt.patch.bz2
Patch1: %{name}-1.0.2-soname_hack-alt.patch
Patch2: libquicktime-1.0.2-alt-fix-libswscale.patch

Obsoletes: %name-xanim, %name-svq, %name-cinepak
Provides: %name-xanim = %version-%release, %name-svq  = %version-%release, %name-cinepak = %version-%release

%define ffmpeg_ver 0.4.8
%define dv_ver 0.102

%if_with ffmpeg
BuildPreReq: ffmpeg-devel >= %ffmpeg_ver
%endif

BuildPreReq: libdv-devel >= %dv_ver

# Automatically added by buildreq on Sun Jan 29 2006
BuildRequires: ffmpeg-devel fontconfig freetype2 gcc-c++ glib2-devel libdv-devel libgtk+2-devel libjpeg-devel liblame-devel libogg-devel libpango-devel libpng-devel libstdc++-devel libvorbis-devel pkg-config xorg-x11-devel zlib-devel libx264-devel anyasm
BuildPreReq: libavc1394-devel libraw1394-devel libfaac-devel libfaad-devel libalsa-devel 
#libjpeg-mmx-devel

# manually removed: glib-devel gcc-g77 gtk+-devel 
#OldBuildRequires: XFree86-devel-static XFree86-libs ffmpeg-devel fontconfig freetype2 gcc-c++ glib2-devel hostinfo libGLU-devel libalsa-devel libatk-devel libavc1394-devel libdv-devel libgtk+2-devel libjpeg-devel libjpeg-mmx-devel liblame-devel libogg-devel libpango-devel libpng-devel libraw1394-devel libstdc++-devel libvorbis-devel pkgconfig xpm xvid zlib-devel libfaac-devel libfaad-devel
# TODO: libavcodec (!) (ffmpeg)
#--with-avcodec=PFX   Prefix where libavcodec is installed (optional)

%description
Libquicktime is a library for reading and writing QuickTime files on
UNIX systems. Video CODECs supported by this library are OpenDivX, MJPA,
JPEG Photo, PNG, RGB, YUV 4:2:2, and YUV 4:2:0 compression.  Supported
audio CODECs are Ogg Vorbis, IMA4, ulaw, and any linear PCM format.

Libquicktime is based on the quicktime4linux library. Libquicktime add
features such as a GNU build tools-based build process and dynamically
loadable CODECs.

%package devel
Summary: Header files for libquicktime
Group: Development/C
Requires: %name = %version-%release
Requires: glib2-devel
Requires: libpng-devel
Requires: libjpeg-devel
Requires: libdv-devel
Requires: libraw1394-devel
Requires: libavc1394-devel
Requires: libogg-devel
Requires: libvorbis-devel

%description devel
Header files for libquicktime.

%package devel-doc
Summary: Development documentation for libquicktime
Group: Development/C
Requires: %name = %version-%release

%description devel-doc
Development documentation (API reference) for libquicktime.

%package utils
Summary: Useful tools to operate at QuickTime files
Group: Video
Requires: %name = %version-%release

%description utils
Useful tools to operate on QuickTime files.

%package vorbis
Summary: Libquicktime plugin supporting the Ogg Vorbis codec.
Group: Video
Requires: %name = %version-%release

%description vorbis
Libquicktime plugin supporting the Ogg Vorbis codec.

%package ffmpeg
Summary: Libquicktime plugin supporting the ffmpeg codec
Group: Video
Requires: %name = %version-%release
Requires: libffmpeg >= %ffmpeg_ver

%description ffmpeg
Libquicktime plugin supporting the ffmpeg codec

%package opendivx
Summary: Libquicktime plugin supporting the opendivx codec
Group: Video
Requires: %name = %version-%release

%description opendivx
Libquicktime plugin supporting the opendivx codec.

%package lame
Summary: Libquicktime plugin supporting the Lame codec
Group: Video
Requires: %name = %version-%release

%description lame
Libquicktime plugin supporting the Lame codec.

%package dv
Summary: Libquicktime plugin supporting the DV codec
Group: Video
Requires: %name = %version-%release
Requires: libdv >= %dv_ver

%description dv
Libquicktime plugin supporting the DV codec.

%if_with faac
%package faac
Summary: Libquicktime plugin supporting the Faac codec
Group: Video
Requires: %name = %version-%release

%description faac
Libquicktime plugin supporting the Faac codec.
%endif

%package faad2
Summary: Libquicktime plugin supporting the Faad2 codec
Group: Video
Requires: %name = %version-%release

%description faad2
Libquicktime plugin supporting the Faad2 codec.

%package x264
Summary: Libquicktime plugin supporting the x264 codec
Group: Video
Requires: %name = %version-%release

%description x264
Libquicktime plugin supporting the x264 codec.

%package devel-static
Summary: Static libquicktime libraries
Group: Development/C
Requires: %name-devel = %version-%release

%description devel-static
Static libquicktime libraries.

%prep
%setup -q -n %name-%version%prerel
%patch -p1
%patch1 -p1
%patch2 -p1

%if_without ffmpeg
#%patch1 -p1
%endif

%build
autoreconf -fisv

%define _optlevel 3
#--with-avcodec=/usr/lib
%configure --enable-gpl \
    %{subst_enable static} \
    %{subst_with x264} \
    --with-cpuflags="$CFLAGS" \
%ifnarch i586 i686 athlon
    --disable-mmx \
%endif

%make_build

%install
%makeinstall
mv -f %buildroot%_docdir/%{name} %buildroot%_pkgdocdir
cp README TODO %buildroot%_pkgdocdir

%find_lang %{name}

# remove non-packaged files
%__rm -f %buildroot%_libdir/%name/*.la

%files -f %{name}.lang
%_libdir/*.so.*
%dir %_libdir/%name/
%_libdir/%name/lqt_audiocodec.so
%_libdir/%name/lqt_rtjpeg.so
%_libdir/%name/lqt_png.so
%_libdir/%name/lqt_mjpeg.so
%_libdir/%name/lqt_videocodec.so
%_pkgdocdir/README
%_pkgdocdir/TODO

%files utils
%_bindir/*
%exclude %_bindir/lqt-config
%_man1dir/*

%files vorbis
%_libdir/%name/lqt_vorbis.so

%if_with ffmpeg
%files ffmpeg
%_libdir/%name/lqt_ffmpeg.so
%endif

%files opendivx
%_libdir/%name/lqt_opendivx.so

%files lame
%_libdir/%name/lqt_lame.so

%files dv
%_libdir/%name/lqt_dv.so

%if_with faac
%files faac
%_libdir/%name/lqt_faac.so
%endif

%files faad2
%_libdir/%name/lqt_faad2.so

%if_with x264
%files x264
%_libdir/%name/lqt_x264.so
%endif

%files devel
%_bindir/lqt-config
%_includedir/*
%_libdir/*.so
%_datadir/aclocal/*
%_pkgconfigdir/*

%files devel-doc
%_pkgdocdir/apiref

%if_enabled static
%files devel-static
%_libdir/*.a
%_libdir/%name/*.a
%endif

%changelog
* Sat Dec 20 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt4
- removed obsolete dependency libjpeg-mmx-devel

* Fri Dec 12 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt3
- temporally disabled x264 plugin

* Mon Sep 29 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt2
- fixed build with new ffmpeg 

* Mon Jun 9 2008 Yury Aliaev <mutabor@altlinux.ru> 1.0.2-alt1
- new version
- reverted back OpenDivX support from 0.9.8
- development documentation put into the separate package devel-doc
- soname versioning hack added

* Sat Sep 16 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt6
- enabled ffmpeg (current Sisyphus allows it again)

* Sat May 06 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt5
- disabled ffmpeg
- faac plugin is enabled again

* Fri Feb 24 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt4
- disabled CPU build detection --with-cpuflags

* Wed Feb 08 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt3
- enabled ffmpeg 

* Mon Feb 06 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt2
- s/xorg-x11-devel-static/xorg-x11-devel/

* Sun Jan 29 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt1
- new version;
- changed license to GPL (enables faad2 && faac codecs)
- removed libjpeg-mmx-devel on x86_64 (thanks to rider@)

* Sun Dec 18 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt0.1.pre2
- new version 0.9.8-pre2

* Sun Dec 18 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt4
- applied spec cleanup of Vitaly Lipatov
  (removed broken dependency gtk+-devel)

* Fri Sep 30 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt3
- fix #6687 (license is LGPL, not GPL)
- plugins removed from main package again (fixed alt1.1)

* Thu Sep 22 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt2
- merged Vitaly Lipatov work with my backport branch; thanks

* Fri Sep 09 2005 Vitaly Lipatov <lav@altlinux.ru> 0.9.7-alt1.1
- fix owner of %_libdir/%name

* Sat Aug 27 2005 Vitaly Lipatov <lav@altlinux.ru> 0.9.7-alt1
- new version
- disable build with glib/gnome1 libraries

* Fri Aug 26 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt0.M24.2
- added my patch to fix crashes on some MOVs

* Tue Jul 19 2005 Igor Vlasenko <viy@altlinux.org> 0.9.7-alt0.M24.1
- backport to M24, changed buildrequires

* Fri Jan 14 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.9.4-alt1
- 0.9.4

* Wed Jul 21 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.3-alt1
- 0.9.3
- obsoletes libquicktime-{xanim,svq,cinepak}
- new Lame plugin.

* Mon Jun 07 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.3
- rebuild with libdv-0.102

* Tue Dec 02 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.2
- do not package .la files.
- do not build devel-static subpackage by default.
- use %%set_verify_elf_method textrel=relaxed, I can't fix rtjpeg 
  asm code.

* Mon Oct 13 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.1
- disabled ffmpeg plugin due not ready for new ffmpeg.

* Wed Oct 01 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1
- 0.9.2 release.

* Wed Nov 20 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt0.8pre1
- 0.9.2pre1.

* Sun Jul 21 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.9.1-alt1
- First build for Sisyphus.
